deps.mk 9.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318
  1. # Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps distclean-pkg pkg-list pkg-search
  4. # Configuration.
  5. AUTOPATCH ?= edown gen_leader gproc
  6. export AUTOPATCH
  7. DEPS_DIR ?= $(CURDIR)/deps
  8. export DEPS_DIR
  9. REBAR_DEPS_DIR = $(DEPS_DIR)
  10. export REBAR_DEPS_DIR
  11. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(DEPS))
  12. ifeq ($(filter $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  13. ifeq ($(ERL_LIBS),)
  14. ERL_LIBS = $(DEPS_DIR)
  15. else
  16. ERL_LIBS := $(ERL_LIBS):$(DEPS_DIR)
  17. endif
  18. endif
  19. export ERL_LIBS
  20. PKG_FILE2 ?= $(CURDIR)/.erlang.mk.packages.v2
  21. export PKG_FILE2
  22. PKG_FILE_URL ?= https://raw.githubusercontent.com/ninenines/erlang.mk/master/packages.v2.tsv
  23. # Verbosity.
  24. dep_verbose_0 = @echo " DEP " $(1);
  25. dep_verbose = $(dep_verbose_$(V))
  26. # Core targets.
  27. ifneq ($(SKIP_DEPS),)
  28. deps::
  29. else
  30. deps:: $(ALL_DEPS_DIRS)
  31. @for dep in $(ALL_DEPS_DIRS) ; do \
  32. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ] ; then \
  33. $(MAKE) -C $$dep IS_DEP=1 || exit $$? ; \
  34. else \
  35. echo "ERROR: No makefile to build dependency $$dep. Consider adding it to AUTOPATCH." ; \
  36. exit 1 ; \
  37. fi ; \
  38. done
  39. endif
  40. distclean:: distclean-deps distclean-pkg
  41. # Deps related targets.
  42. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  43. # While Makefile file could be GNUmakefile or makefile,
  44. # in practice only Makefile is needed so far.
  45. define dep_autopatch
  46. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  47. if [ 0 != `grep -ci rebar $(DEPS_DIR)/$(1)/Makefile` ]; then \
  48. $(call dep_autopatch2,$(1)); \
  49. elif [ 0 != `find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk | xargs grep -ci rebar` ]; then \
  50. $(call dep_autopatch2,$(1)); \
  51. else \
  52. $(call dep_autopatch_erlang_mk,$(1)); \
  53. fi \
  54. else \
  55. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  56. $(call dep_autopatch_noop,$(1)); \
  57. else \
  58. $(call dep_autopatch2,$(1)); \
  59. fi \
  60. fi
  61. endef
  62. define dep_autopatch2
  63. if [ ! -f $(DEPS_DIR)/$(1)/rebar.config ]; then \
  64. $(call dep_autopatch_gen,$(1)); \
  65. else \
  66. $(call dep_autopatch_rebar,$(1)); \
  67. fi
  68. endef
  69. define dep_autopatch_noop
  70. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  71. endef
  72. # Overwrite erlang.mk with the current file by default.
  73. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  74. define dep_autopatch_erlang_mk
  75. rm -f $(DEPS_DIR)/$(1)/erlang.mk; \
  76. cd $(DEPS_DIR)/$(1)/ && ln -s ../../erlang.mk; \
  77. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
  78. endef
  79. else
  80. define dep_autopatch_erlang_mk
  81. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
  82. endef
  83. endif
  84. define dep_autopatch_gen
  85. printf "%s\n" \
  86. "ERLC_OPTS = +debug_info" \
  87. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile; \
  88. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
  89. endef
  90. define dep_autopatch_rebar
  91. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  92. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  93. fi; \
  94. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  95. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1)))
  96. endef
  97. define dep_autopatch_rebar.erl
  98. {ok, Conf} = file:consult("$(DEPS_DIR)/$(1)/rebar.config"),
  99. Write = fun (Text) ->
  100. file:write_file("$(DEPS_DIR)/$(1)/Makefile", Text, [append])
  101. end,
  102. Escape = fun (Text) ->
  103. re:replace(Text, "\\\\$$$$", "\$$$$$$$$", [global, {return, list}])
  104. end,
  105. Write("ERLC_OPTS = +debug_info\n\n"),
  106. fun() ->
  107. File = case lists:keyfind(deps, 1, Conf) of
  108. false -> [];
  109. {_, Deps} ->
  110. [begin
  111. Name = element(1, Dep),
  112. {Method, Repo, Commit} = case element(3, Dep) of
  113. {git, R} -> {git, R, master};
  114. {M, R, {branch, C}} -> {M, R, C};
  115. {M, R, {tag, C}} -> {M, R, C};
  116. {M, R, C} -> {M, R, C}
  117. end,
  118. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  119. end || Dep <- Deps, tuple_size(Dep) > 2]
  120. end
  121. end(),
  122. fun() ->
  123. First = case lists:keyfind(erl_first_files, 1, Conf) of false -> []; {_, Files} ->
  124. Names = [[" ", begin "lre." ++ Elif = lists:reverse(F), lists:reverse(Elif) end]
  125. || "src/" ++ F <- Files],
  126. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  127. end
  128. end(),
  129. fun() ->
  130. case lists:keyfind(port_env, 1, Conf) of
  131. {_, Vars} ->
  132. [Write(K ++ " = $$$$\(shell echo " ++ Escape(V) ++ "\)\n") || {K, V} <- Vars],
  133. Write("CFLAGS += $$$$\(DRV_CFLAGS\)\n"),
  134. Write("CXXFLAGS += $$$$\(DRV_CFLAGS\)\n"),
  135. Write("LDFLAGS += $$$$\(DRV_LDFLAGS\)\n");
  136. _ -> ok
  137. end
  138. end(),
  139. fun() ->
  140. case filelib:is_dir("$(DEPS_DIR)/$(1)/c_src") of
  141. false -> ok;
  142. true ->
  143. Sources = [[" ./c_src/", S] || S <- filelib:wildcard("*.{c,C,cc,cpp}", "$(DEPS_DIR)/$(1)/c_src")],
  144. Write(io_lib:format("SOURCES := ~s\n", [Sources]))
  145. end
  146. end(),
  147. Write("\n\nrebar_dep: pre-deps deps pre-app app\n"),
  148. Write("\npre-deps::\n"),
  149. Write("\npre-app::\n"),
  150. fun() ->
  151. case lists:keyfind(pre_hooks, 1, Conf) of
  152. false -> ok;
  153. {_, Hooks} ->
  154. [case H of
  155. {'get-deps', Command} ->
  156. Write("\npre-deps::\n\t" ++ Escape(Command) ++ "\n");
  157. {compile, Command} ->
  158. Write("\npre-app::\n\t" ++ Escape(Command) ++ "\n");
  159. {Regex, compile, Command0} ->
  160. case re:run("$(PLATFORM)", Regex, [{capture, none}]) of
  161. match ->
  162. Command = case Command0 of
  163. "make -C" ++ _ -> Escape(Command0);
  164. "gmake -C" ++ _ -> Escape(Command0);
  165. "make " ++ Command1 -> "make -f Makefile.orig.mk " ++ Escape(Command1);
  166. "gmake " ++ Command1 -> "gmake -f Makefile.orig.mk " ++ Escape(Command1);
  167. _ -> Command0
  168. end,
  169. Write("\npre-app::\n\t" ++ Command ++ "\n");
  170. nomatch ->
  171. ok
  172. end;
  173. _ -> ok
  174. end || H <- Hooks]
  175. end
  176. end(),
  177. Write("\ninclude ../../erlang.mk"),
  178. halt()
  179. endef
  180. define dep_autopatch_appsrc.erl
  181. AppSrcOut = "$(DEPS_DIR)/$(1)/src/$(1).app.src",
  182. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(DEPS_DIR)/$(1)/ebin/$(1).app"; true -> AppSrcOut end,
  183. case filelib:is_regular(AppSrcIn) of
  184. false -> ok;
  185. true ->
  186. fun() ->
  187. {ok, [{application, $(1), L}]} = file:consult(AppSrcIn),
  188. L2 = case lists:keyfind(modules, 1, L) of {_, _} -> L; false -> [{modules, []}|L] end,
  189. L3 = case lists:keyfind(vsn, 1, L2) of {vsn, git} -> lists:keyreplace(vsn, 1, L2, {vsn, "git"}); _ -> L2 end,
  190. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}]))
  191. end(),
  192. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  193. end,
  194. halt()
  195. endef
  196. define dep_fetch
  197. if [ "$$$$VS" = "git" ]; then \
  198. git clone -q -n -- $$$$REPO $(DEPS_DIR)/$(1); \
  199. cd $(DEPS_DIR)/$(1) && git checkout -q $$$$COMMIT; \
  200. elif [ "$$$$VS" = "hg" ]; then \
  201. hg clone -q -U $$$$REPO $(DEPS_DIR)/$(1); \
  202. cd $(DEPS_DIR)/$(1) && hg update -q $$$$COMMIT; \
  203. elif [ "$$$$VS" = "svn" ]; then \
  204. svn checkout -q $$$$REPO $(DEPS_DIR)/$(1); \
  205. elif [ "$$$$VS" = "cp" ]; then \
  206. cp -R $$$$REPO $(DEPS_DIR)/$(1); \
  207. else \
  208. echo "Unknown or invalid dependency: $(1). Please consult the erlang.mk README for instructions." >&2; \
  209. exit 78; \
  210. fi
  211. endef
  212. define dep_target
  213. $(DEPS_DIR)/$(1):
  214. @mkdir -p $(DEPS_DIR)
  215. ifeq (,$(dep_$(1)))
  216. @if [ ! -f $(PKG_FILE2) ]; then $(call core_http_get,$(PKG_FILE2),$(PKG_FILE_URL)); fi
  217. $(dep_verbose) DEPPKG=$$$$(awk 'BEGIN { FS = "\t" }; $$$$1 == "$(1)" { print $$$$2 " " $$$$3 " " $$$$4 }' $(PKG_FILE2);); \
  218. VS=$$$$(echo $$$$DEPPKG | cut -d " " -f1); \
  219. REPO=$$$$(echo $$$$DEPPKG | cut -d " " -f2); \
  220. COMMIT=$$$$(echo $$$$DEPPKG | cut -d " " -f3); \
  221. $(call dep_fetch,$(1))
  222. else
  223. ifeq (1,$(words $(dep_$(1))))
  224. $(dep_verbose) VS=git; \
  225. REPO=$(dep_$(1)); \
  226. COMMIT=master; \
  227. $(call dep_fetch,$(1))
  228. else
  229. ifeq (2,$(words $(dep_$(1))))
  230. $(dep_verbose) VS=git; \
  231. REPO=$(word 1,$(dep_$(1))); \
  232. COMMIT=$(word 2,$(dep_$(1))); \
  233. $(call dep_fetch,$(1))
  234. else
  235. $(dep_verbose) VS=$(word 1,$(dep_$(1))); \
  236. REPO=$(word 2,$(dep_$(1))); \
  237. COMMIT=$(word 3,$(dep_$(1))); \
  238. $(call dep_fetch,$(1))
  239. endif
  240. endif
  241. endif
  242. @if [ -f $(DEPS_DIR)/$(1)/configure.ac ]; then \
  243. echo " AUTO " $(1); \
  244. cd $(DEPS_DIR)/$(1) && autoreconf -vif; \
  245. fi
  246. -@if [ -f $(DEPS_DIR)/$(1)/configure ]; then \
  247. echo " CONF " $(1); \
  248. cd $(DEPS_DIR)/$(1) && ./configure; \
  249. fi
  250. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  251. @$(call dep_autopatch,$(1))
  252. endif
  253. endef
  254. $(foreach dep,$(DEPS),$(eval $(call dep_target,$(dep))))
  255. distclean-deps:
  256. $(gen_verbose) rm -rf $(DEPS_DIR)
  257. # Packages related targets.
  258. $(PKG_FILE2):
  259. @$(call core_http_get,$(PKG_FILE2),$(PKG_FILE_URL))
  260. pkg-list: $(PKG_FILE2)
  261. @cat $(PKG_FILE2) | awk 'BEGIN { FS = "\t" }; { print \
  262. "Name:\t\t" $$1 "\n" \
  263. "Repository:\t" $$3 "\n" \
  264. "Website:\t" $$5 "\n" \
  265. "Description:\t" $$6 "\n" }'
  266. ifdef q
  267. pkg-search: $(PKG_FILE2)
  268. @cat $(PKG_FILE2) | grep -i ${q} | awk 'BEGIN { FS = "\t" }; { print \
  269. "Name:\t\t" $$1 "\n" \
  270. "Repository:\t" $$3 "\n" \
  271. "Website:\t" $$5 "\n" \
  272. "Description:\t" $$6 "\n" }'
  273. else
  274. pkg-search:
  275. $(error Usage: $(MAKE) pkg-search q=STRING)
  276. endif
  277. ifeq ($(PKG_FILE2),$(CURDIR)/.erlang.mk.packages.v2)
  278. distclean-pkg:
  279. $(gen_verbose) rm -f $(PKG_FILE2)
  280. endif
  281. help::
  282. @printf "%s\n" "" \
  283. "Package-related targets:" \
  284. " pkg-list List all known packages" \
  285. " pkg-search q=STRING Search for STRING in the package index"